export declare function up<TEntrances extends object, TInclude extends EntranceKey<TEntrances> | EntranceKeyPattern>(entrances: TEntrances, includes?: TInclude[]): Promise<UpEntrances<TEntrances, TInclude, never>>;
export declare function up<TEntrances extends object, TInclude extends EntranceKey<TEntrances> | EntranceKeyPattern, TExclude extends EntranceKey<TEntrances> | EntranceKeyPattern>(entrances: TEntrances, match: {
    includes: TInclude[];
    excludes: TExclude[];
}): Promise<UpEntrances<TEntrances, TInclude, TExclude>>;
export type EntranceKeyPattern = `${string}*${string}`;
type EntranceKey<TEntrances extends object> = Extract<keyof TEntrances, string>;
type UpEntrances<TEntrances extends object, TInclude extends string, TExclude extends string> = {
    [TKey in keyof TEntrances]: TKey extends KeyPattern<TInclude> ? TKey extends KeyPattern<TExclude> ? TEntrances[TKey] : Awaited<TEntrances[TKey]> : TEntrances[TKey];
};
type KeyPattern<TKeyPattern extends string> = TKeyPattern extends `${infer TPrefix}*${infer TPostfix}` ? `${TPrefix}${string}${TPostfix}` : TKeyPattern;
export {};
